#include "GL_RendererGroupingVisitor.h"
#include "GL_Group.h"
#include "GL_StaticGroup.h"
#include "GL_Transform.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace GL {

RendererGroupingVisitor::RendererGroupingVisitor()
: GroupingVisitor()
{
  define(Recorder<Transform>::getEnterFunction(&RendererGroupingVisitor::enterTransform));
  define(Recorder<Transform>::getLeaveFunction(&RendererGroupingVisitor::leaveTransform));
}

void RendererGroupingVisitor::enterTransform(Transform *T) 
{
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glMultMatrixf(&T->getTransformMatrix().front());
}

void RendererGroupingVisitor::leaveTransform(Transform *) 
{
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix(); 
}

}
}
