#include "X3D_InlineLoader.h"
#include "DFSGraphTraversal.h"
#include "X3D_InlineLoaderCoreVisitor.h"
#include "X3D_InlineLoaderNetworkingVisitor.h"

namespace X3DTK {
namespace X3D {

InlineLoader::InlineLoader()
: X3DOnePassProcessor()
{
  setGraphTraversal(new DFSGraphTraversal());
  setComponentVisitor(new InlineLoaderCoreVisitor());
  setComponentVisitor(new InlineLoaderNetworkingVisitor());
}

InlineLoader::~InlineLoader()
{
  Singleton<InlineLoaderStateVariables>::removeInstance();
}

void InlineLoader::load(SFNode N, bool force)
{
  Singleton<InlineLoaderStateVariables>::getInstance()->setForce(force);
  
  Singleton<InlineLoaderStateVariables>::getInstance()->init();
  traverse(N);
  Singleton<InlineLoaderStateVariables>::getInstance()->finish();
  
  while (Singleton<InlineLoaderStateVariables>::getInstance()->hasInline())
  {
    Singleton<InlineLoaderStateVariables>::getInstance()->init();
    traverse(N);
    Singleton<InlineLoaderStateVariables>::getInstance()->finish();
  }
}

}
}
