#include "X3D_SharedCoordComputer.h"
#include "X3D_SharedCoordComputerRenderingVisitor.h"
#include "DFSGraphTraversal.h"
#include "X3D_X3DNode.h"
#include "X3D_Scene.h"

namespace X3DTK {
namespace X3D {

SharedCoordComputer::SharedCoordComputer()
: X3DOnePassProcessor()
{
  setGraphTraversal(new DFSGraphTraversal());
  setComponentVisitor(new SharedCoordComputerRenderingVisitor());
}

SharedCoordComputer::~SharedCoordComputer()
{
  Singleton<SharedCoordComputerStateVariables>::removeInstance();
}

void SharedCoordComputer::compute(Scene *S)
{
  compute(static_cast<X3DNode *>(S));
  
  S->getProcessHistory().addEntry("X3D::SharedCoordComputer");
}

void SharedCoordComputer::compute(X3DNode *N)
{
  traverse(N);
  Singleton<SharedCoordComputerStateVariables>::getInstance()->finish();
}


}
}
