#include "X3DOnePassProcessor.h"

#include <iostream>
using namespace std;


namespace X3DTK {

X3DOnePassProcessor::X3DOnePassProcessor()
: X3DProcessor(), _graphTraversal(0)
{
}
  
X3DOnePassProcessor::~X3DOnePassProcessor()
{
  if (_graphTraversal != 0)
    delete _graphTraversal;
}

void X3DOnePassProcessor::setWalker(Walker *walker)
{
  if (_graphTraversal != 0)
    _graphTraversal->setWalker(walker);
}

void X3DOnePassProcessor::setComponentVisitor(X3DComponentVisitor *component)
{
  if (_graphTraversal != 0)
    _graphTraversal->setComponentVisitor(component);
}

void X3DOnePassProcessor::setGraphTraversal(GraphTraversal *graphTraversal)
{
  if (_graphTraversal != 0)
    delete _graphTraversal;
    
  _graphTraversal = graphTraversal; 
}

void X3DOnePassProcessor::traverse(X3DAbstractNode *N) const
{
  if (_graphTraversal != 0)
    _graphTraversal->traverse(N);
}

}
